(function() {
  var counter = 0;

  h5 = function(query, root) {
    if (!query) { return []; }
    if (query.constructor == Array) { return query; }
    if (typeof query != "string") { return Array(query); }
    if (typeof root == "string") {
      root = doc.getElementbyId(root);
      if (!root) { return []; }
    }

    root = root||document;
    var rootIsDoc = (root.nodeType == 9);

    var doc = rootIsDoc ? root : (root.ownerDocument||document);

    // rewrite the query to be ID rooted
    if(!rootIsDoc || (">~+".indexOf(query.charAt(0)) >= 0)){
      root.id = root.id || ("h5Unique" + (counter++) );
      query = "#" + root.id + " " + query;
    }

    // rewrite the query to not choke on something like ".yada.yada >"
    // by adding a final descendant component

    if(">~+".indexOf(query.slice(-1)) >= 0){
      query += " *";
    }
    return Array.prototype.slice.call(doc.querySelectorAll(query));
  };

  h5.one = function(query, root) {
    return h5(query, root)[0];
  };

  h5.extend = function(obj, properties) {
    for (var prop in properties) {
      if (properties.hasOwnProperty(prop)) {
        Object.defineProperty(obj, prop, {
          value: properties[prop],
          writable: true,
          enumerable: false,
          configurable: true
        });
      }
    }
  };

  // Give elements the API we always wanted them to have!
  h5.extend(HTMLElement.prototype, {

    remove: function() {
      if (this.parentNode) {
        this.parentNode.removeChild(this);
      }
      return this;
    },

    hasClass: function(c) {
      return ((" "+ this.className +" ").indexOf(" " + c + " ") >= 0);
    },

    addClass: function(c) {
      if (!this.hasClass(c)) {
        this.className += " " + c;
      }
    },

    removeClass: function(c) {
      var re = new RegExp("(\\s|^)" + c + "(\\s|$)");
      this.className = this.className.replace(re," ");
    },

    // ...
  });

})();
